App per xm, prende i contenuti dal sito e te li salva nel cellulare.

<img src="http://git.lattuga.net/hacklabbo/Ilovexm24/raw/174939a682216d735bb1aebd89b547e1912318aa/screenshot1.png" style="border:solid 1px black;border-radius:20px;" />

## Environment ##

### NodeJs ###

add gpg key using 

`curl -s https://deb.nodesource.com/gpgkey/nodesource.gpg.key | apt-key add -`

add APT repo (verify/create) nodesource.list file in /etc/apt/sources.list.d with:

```
deb https://deb.nodesource.com/node_6.x jessie main
deb-src https://deb.nodesource.com/node_6.x jessie main
```

Alternative setup (it supports Kali, Debian, Mint, ...): 

`sudo curl -sL https://deb.nodesource.com/setup_6.x | bash -`

(it supports Kali, Debian, Mint, ...)

Cleanup: 

`apt-get purge nodejs`

Refresh: 

`apt-get update && apt-get install nodejs nom`

ADK (android developer kit) e

### Cordova CLI ###

Cordova si intalla con npm, packager di nodejs

`npm install -g cordova`

### Android tool ###

ADK (android developer kit) 

P.S. Con l'ultima versione di Android Studio è necessario scaricare a mano gli [android tools](https://dl.google.com/android/repository/tools_r25.2.3-linux.zip). 

### Appunti ###

http://www.digitigrafo.it/module/1249

## Build del progetto ##

`cordova platform rm android`

Per rimuovere la piattaforma vecchie di Android

`cordova platform add android`
	
Per aggiungere la piattaforma nuova. Durante questa operaionze i seguenti plugin verranno auto installti:

* cordova-plugin-compat
* cordova-plugin-file
* cordova-plugin-media
* cordova-plugin-whitelist
* cordova-sqlite-storage
* phonegap-plugin-push
		
```
cordova plugin add cordova-plugin-network-information \
		cordova-plugin-x-socialsharing \
		cordova-plugin-splashscreen
```

Forse non serve, ma l'howto di [cordova-plugin-x-socialsharing](https://github.com/EddyVerbruggen/SocialSharing-PhoneGap-Plugin) dicono di farlo:

`cordova prepare`

Per installare il plugin sulla rete che non viene installato in automatico

`cordova run android`

Per lanciare l'emulatore Android con l'applicazione.
Ovviamente si deve aver configurato il proprio environment correttamente.

## TODO, ISSUE e FEATURE ##

Usiamo l'[issue tracker](https://git.lattuga.net/hacklabbo/Ilovexm24/issues) non il wiki.
