function myJsonCategory(Qcategory, div, addTagCategory) {
    $.mobile.loading('show');
    FONTE.dbHandler.executeSql("SELECT * FROM xm24_posts WHERE category = ? ORDER BY date COLLATE NOCASE DESC;", [Qcategory], function (resultSet) {
        var items = [];
        for (var i = 0; i < resultSet.rows.length; i++) {
            var val = JSON.parse(resultSet.rows.item(i).post);
            var id = val.id;
            var time = val.modified;
            var title = val.title.rendered;
            var url = val.guid.rendered;
            var splitTime = time.split("T");
            var cleanTime = splitTime[0];
            var tag = '';
            var cattag = '';
            /* if (addTagCategory) {
                 $.each(val.tags, function (index, value) {
                     if (value == 43) {

                     }
                     if (value == 36) {

                     }
                 });
                 //key mi dice l'indice'
                 items.push("<li class='"+ cattag +"'><a href='#singleQpost' data-post='" + id + "'>" + title + "</a><br/><small>" + cleanTime + "</small><span>" + tag + "</span>|</li>");
             }
            else {*/
                items.push("<li><a href='#singleQpost' data-post='" + id + "'>" + title + "</a><br/><small>" + cleanTime + "</small></li>");

        }
        $("<ul/>", {
            "class": "my-new-list"
            , html: items.join("")
        }).prependTo(div);
    });
    $.mobile.loading('hide');
};

var drawListPost = function(div, resultSet, position) {
    var items = [];
    for (var i = 0; i < resultSet.rows.length; i++) {
        var val = JSON.parse(resultSet.rows.item(i).post);
        var id = val.id;
        var date = val.modified;
        var title = val.title.rendered;
        var url = val.guid.rendered;
        var cleanTime = EVENTS.formatDate(date, EVENTS.dateFormat.display.date);
        //key mi dice l'indice'
        items.push("<li><a href='#singleQpost' data-post='" + id + "'>" + title + "</a><br/><small>" + cleanTime + "</small>");
    }
    
    var ul = $("<ul/>", {
        "class": "my-new-list", 
        html: items.join("")
    })
    
    if(position == 'append'){
        ul.appendTo(div);
    } else if(position == 'prepend'){
        ul.prependTo(div);
    }
} 

var appendPostList = function(div, resultSet, categories, fallback) {
    var type = getObjKey(FONTE.categories, categories);
    
    if (resultSet.rows.length > 0) {
        FONTE.page_loaded[type]++;
        drawListPost(div, resultSet, 'append');
    } else if (fallback) {
        fallback();
    } else {
        toastr.info("Non ci sono altri articoli da visualizzare");
    }
};

var prependPostsList = function(div, resultSet, categories, fallback) {
    var type = getObjKey(FONTE.categories, categories);
    
    $(div).empty();
    if (resultSet.rows.length > 0) {
        FONTE.page_loaded[type]++;
        drawListPost(div, resultSet, 'prepend');
    } else if (fallback) {
        fallback(div, categories);
    } else {
        drawNoPostsFound(div);
    }
};

function drawNoPostsFound(div) {
    $(div).empty();
    $(div).append('<span>Non ci sono nuovi contenuti.</span>')
}

function sqlErrHandler(error){
    console.log(error.message);
}

var getCategoryWhere = function(categories) {
    var catsWhere = "";
    for(var i = 0, len = categories.length; i < len; i++) {
        var cat = categories[i];
        var c = 'catid = '+ cat + ' ';
        if(i == 0) {
            catsWhere = '(' + c;
        } else if(i == len -1) {
            catsWhere += 'OR ' + c + ')';
        } else {
            catsWhere += 'OR ' + c;
        }
    }
    
    return catsWhere;
}

var POST = POST || {};
POST.sql = {
    init: "SELECT * FROM xm24_posts JOIN xm24_cats_to_posts USING(id) WHERE ",
    end : "ORDER BY date COLLATE NOCASE DESC LIMIT ?"
}

var selectLastNews = function(div, categories) {
    var catsWhere = getCategoryWhere(categories);
    
    var sql = POST.sql.init + catsWhere + POST.sql.end;
    FONTE.dbHandler.executeSql(sql, [REST_PARAMS.max_page], function (resultSet) {
        prependPostsList(div, resultSet, categories);
    }, sqlErrHandler);    
}

function renderLastNews(div, categories) {
    var storage = window.localStorage;
    var lastnewsDate = storage.getItem('db_lastnews_date');
    var firstTime = storage.getItem('db_lastnews_firsttime');
    
    if (firstTime == 'yes') {
        selectLastNews(div, categories);
    } else if (firstTime == 'no') {
        if (lastnewsDate) {
            var sql = POST.sql.init + "date > ? AND " + getCategoryWhere(categories) + POST.sql.end;
            FONTE.dbHandler.executeSql(sql, [lastnewsDate, REST_PARAMS.max_page], function (resultSet) {    
                prependPostsList(div, resultSet, categories, selectLastNews);
            }, sqlErrHandler);
        } else {
            selectLastNews(div, categories);
            toastr.info("Non ci sono nuovi contenuti");
        }
    } else {
        drawNoPostsFound(div);
    }
};

function renderPrevNews(div, categories, page, callback){
    var sql = POST.sql.init + getCategoryWhere(categories) + POST.sql.end + ', ?';
    FONTE.dbHandler.executeSql(sql, [page * REST_PARAMS.max_page, (page+1) * REST_PARAMS.max_page], function (resultSet) {
        appendPostList(div, resultSet, categories, callback);
    }, sqlErrHandler);
}

function myJsonLastPage(div) {
    var storage = window.localStorage;
    var lastnewsDate = storage.getItem('db_lastnews_date');
    var firstTime = storage.getItem('db_lastnews_firsttime');
    if (firstTime != 'yes') {
        if (lastnewsDate) {
            FONTE.dbHandler.executeSql("SELECT * FROM xm24_posts WHERE date > ? ORDER BY date COLLATE NOCASE DESC LIMIT 40;", [lastnewsDate], function (resultSet) {
                var items = [];
                $(div).empty();
                if (resultSet.rows.length > 0) {
                    for (var i = 0; i < resultSet.rows.length; i++) {
                        var val = JSON.parse(resultSet.rows.item(i).post);
                        var id = val.id;
                        var time = val.modified;
                        var title = val.title.rendered;
                        var url = val.guid.rendered;
                        // console.log(Url);
                        var splitTime = time.split("T");
                        var cleanTime = splitTime[0];
                        //key mi dice l'indice'
                        items.push("<li><a href='#singleQpost' data-post='" + id + "'>" + title + "</a><br/><small>" + cleanTime + "</small>");
                    }
                    $("<ul/>", {
                        "class": "my-new-list"
                        , html: items.join("")
                    }).prependTo(div);
                } else {
                    $(div).empty();
                    $(div).append('<span>Non ci sono nuovi contenuti.</span>')
                }
            });
        } else {
            $(div).empty();
            $(div).append('<span>Tutti i contenuti sono nuovi.</span>')
        }
    } else {
        $(div).empty();
        $(div).append('<span>Tutti i contenuti sono nuovi.</span>')
    }
};

function myJsonCategoryPaginated(Qcategory, div, pageNumber) {
    $.mobile.loading('show');
    FONTE.dbHandler.executeSql("SELECT * FROM xm24_posts WHERE category = ? ORDER BY date COLLATE NOCASE DESC;", [Qcategory], function (resultSet) {
        var items = [];
        $(div).empty();
        for (var i = 0; i < resultSet.rows.length; i++) {
            var val = JSON.parse(resultSet.rows.item(i).post);
            var id = val.id;
            var time = val.modified;
            var title = val.title.rendered;
            var url = val.guid.rendered;
            var tag = val.tags;
            var splitTime = time.split("T");
            var cleanTime = splitTime[0];
            //key mi dice l'indice'
            items.push("<li><a href='#singleQpost' data-post='" + id + "'>" + title + "</a><br/><small>" + cleanTime + "</small></li>");
        }
        $("<ul/>", {
            "class": "my-new-list"
            , html: items.join("")
        }).prependTo(div);
    }, function (error) {
        console.log('errore myJsonCategoryPaginated: ' + error);
    });
    $.mobile.loading('hide');
};

function drawPost(div_title, div_content, resultSet){
    for (var i = 0; i < resultSet.rows.length; i++) {
        var val = JSON.parse(resultSet.rows.item(i).post);
        var id = val.id;
        var time = val.modified;
        var title = val.title.rendered;
        var url = val.guid.rendered;
        var content = val.content.rendered;
        content = findImg(content);

        $(div_title).html(title);
        //key mi dice l'indice'
        $(div_content).html("<p>" + content + "</p>");
    }
}

function drawEvent(div_title, div_content, resultSet){
    for (var i = 0; i < resultSet.rows.length; i++) {
        var val = resultSet.rows.item(i);
        var evInitDate = EVENTS.formatDate(val.initDate, EVENTS.displayDateFormat);
        var evEndDate = EVENTS.formatDate(val.endDate, EVENTS.displayDateFormat);
        
        var id = val.id;
        var title = val.title;
        var url = val.url;
        var content = val.description;
        var geo = val.geo;

        $(div_title).html(title);
        //key mi dice l'indice'
        $(div_content).html("<p>" + content + "</p>");
    }
}

function myJsonPost(Qid, div_title, div_content, _class) {
    var table = "xm24_posts";
    if(_class){
        table = EVENTS.table.single;
    }

    FONTE.dbHandler.executeSql("SELECT * FROM " + table + " WHERE id = ?;", [Qid], function(resultSet) {
        if(!_class){
            drawPost(div_title, div_content, resultSet);
        } else {
            drawEvent(div_title, div_content, resultSet);
        }
    }, function (error) {
        console.log(error);
    });
};

function myJsonPage(Qid, div_title, div_content) {
    $.mobile.loading('show');
    var pageId = parseInt(Qid);
    FONTE.dbHandler.executeSql("SELECT * FROM xm24_pages WHERE id = ?;", [pageId], function (resultSet) {
        for (var i = 0; i < resultSet.rows.length; i++) {
            var data = resultSet.rows.item(i);
            var id = data.id;
            var time = data.time;
            var title = data.title;
            var content = data.page;
            content = findImg(content);
            $(div_title).html(title);
            //key mi dice l'indice'
            $(div_content).html("<p>" + content + "</p>");
        }
    });
    $.mobile.loading('hide');
};

function myJsonRandomPost(div_title, div_content) {
    $.mobile.loading('show');
    FONTE.dbHandler.executeSql("SELECT * FROM xm24_posts ORDER BY RANDOM() LIMIT 1;", [], function (resultSet) {
        for (var i = 0; i < resultSet.rows.length; i++) {
            var val = JSON.parse(resultSet.rows.item(i).post);
            var id = val.id;
            var time = val.modified;
            var title = val.title.rendered;
            var url = val.guid.rendered;
            var content = val.content.rendered;
            content = findImg(content);
            $(div_title).html(title);
            //key mi dice l'indice'
            $(div_content).html("<p>" + content + "</p>");
        }
    });
    $.mobile.loading('hide');
};

function myJsonPostByTagList(idTag, div) {
    $.mobile.loading('show');
    var tagid = parseInt(idTag);
    FONTE.dbHandler.executeSql("SELECT * FROM xm24_tags_to_posts WHERE tagid = ?;", [tagid], function (resultSet) {
        var items = [];
        var finishCounter = 0;
        for (var i = 0; i < resultSet.rows.length; i++) {
            var val = resultSet.rows.item(i);
            FONTE.dbHandler.executeSql("SELECT * FROM xm24_posts WHERE id = ? ORDER BY title COLLATE NOCASE ASC;", [val.id], function (resultSetPost) {
                finishCounter++;
                for (var n = 0; n < resultSetPost.rows.length; n++) {
                    var val = JSON.parse(resultSetPost.rows.item(n).post);
                    var id = val.id;
                    var time = val.modified;
                    var title = val.title.rendered;
                    var url = val.guid.rendered;
                    var splitTime = time.split("T");
                    var cleanTime = splitTime[0];
                    //key mi dice l'indice'
                    items.push({
                        item: "<li><a href='#singleQpost' data-post='" + id + "'>" + title + "</a><br/><small>" + cleanTime + "</li>"
                        , title: title
                    });
                }
                // fallo solo quando items è stato riempito
                if (finishCounter >= resultSet.rows.length - 1) {
                    $(div).empty();
                    $("<ul/>", {
                        "class": "my-new-list"
                        , html: function () {
                            function compare(a, b) {
                                if (a.title < b.title) return -1;
                                if (a.title > b.title) return 1;
                                return 0;
                            }
                            items.sort(compare);
                            var finalHtml = "";
                            for (var i = 0; i < items.length; i++) {
                                finalHtml += items[i].item;
                            }
                            return finalHtml;
                        }()
                    }).prependTo(div);
                }
            });
        }
    }, function (error) {
        console.log(error);
    });
    $.mobile.loading('hide');
};

function initTag(div) {
    $.mobile.loading('show');
    FONTE.dbHandler.executeSql("SELECT * FROM xm24_tags ORDER BY date COLLATE NOCASE DESC;", [], function (resultSet) {
        var items = [];
        for (var i = 0; i < resultSet.rows.length; i++) {
            var val = JSON.parse(resultSet.rows.item(i).tag);
            var name = val.name;
            var slug = val.slug;
            var id = val.id;
            items.push("<li><img src='./image/virgolette_1.png' class='epuntato'/><a href='#posttag' data-post='" + id + "' >" + name + "</a><br/></li>");
        }
        $(div).empty();
        $("<ul/>", {
            "class": "my-new-list"
            , html: items.join("")
        }).prependTo(div);
    }, function (error) {
        console.log(error);
    });
    $.mobile.loading('hide');
};

function createDB() {
    //crea il databse per i posts se non esiste
    FONTE.dbHandler = window.sqlitePlugin.openDatabase({
        name: FONTE.dbName
        , location: 'default'
    }, function () {
        FONTE.dbHandler.executeSql('CREATE TABLE IF NOT EXISTS xm24_posts (id INTEGER PRIMARY KEY, title, date, post)');
        
        FONTE.dbHandler.executeSql('CREATE TABLE IF NOT EXISTS xm24_cats (catid INTEGER PRIMARY KEY, title, cat)');
        FONTE.dbHandler.executeSql('CREATE TABLE IF NOT EXISTS xm24_cats_to_posts (id, catid, PRIMARY KEY (id, catid))');
        
        FONTE.dbHandler.executeSql('CREATE TABLE IF NOT EXISTS xm24_tags (id INTEGER PRIMARY KEY, title, tag)');
        FONTE.dbHandler.executeSql('CREATE TABLE IF NOT EXISTS xm24_tags_to_posts (id, tagid)');
        FONTE.dbHandler.executeSql('CREATE TABLE IF NOT EXISTS xm24_pages (id INTEGER PRIMARY KEY, title, date, page)');
        FONTE.dbHandler.executeSql('CREATE TABLE IF NOT EXISTS xm24_events_single (id INTEGER PRIMARY KEY, title, description, initDate, endDate, url, geo)');
        FONTE.dbHandler.executeSql('CREATE TABLE IF NOT EXISTS xm24_tags_to_events (id, tagid)');
        FONTE.dbHandler.executeSql('CREATE TABLE IF NOT EXISTS xm24_events_repeat (id INTEGER PRIMARY KEY, title, description, initDate, endDate, url, geo)');
    }, function () {
        console.log('error');
        console.log(arguments);
    });
};

function insertOrUpdateCatToPost(id, catId) {
    FONTE.dbHandler.executeSql('INSERT OR REPLACE INTO xm24_cats_to_posts VALUES (?,?)', [id, catId], function (resultSet) {
        console.log('resultSet.insertId: ' + resultSet.insertId);
        console.log('resultSet.rowsAffected: ' + resultSet.rowsAffected);
    }, function (error) {
        console.log('INSERT error: ' + error.message);
        //feedback
        $("#aggiorna").attr("src", "./image/aggiorna.png");
    });
}

function deleteDB() {
    window.sqlitePlugin.deleteDatabase({
        name: FONTE.dbName
        , location: 'default'
    });
    var storage = window.localStorage;
    storage.setItem('db_update_date', null);
    storage.setItem('db_lastnews_date', null);
    createDB();
};

function getSinglePageRecur(url, category, pagenum) {
    $.ajax({
        dataType: "json"
        , url: url + "&categories=" + category + "&page=" + pagenum
        , success: function (data, textStatus, jqXHR) {
            var totalPages = jqXHR.getResponseHeader('X-WP-TotalPages');
            if (pagenum == totalPages || totalPages == 0) FONTE.updatedCategoriesCount += 1;
            FONTE.neededPostsCount += data.length;
            if (FONTE.updatedCategoriesCount >= FONTE.categoriesList.length && FONTE.neededPostsCount == 0) {
                toastr.info('Nessun nuovo articolo.');

                var date = new Date();
                var currentUpdate = date.getFullYear() + '-' + ('0' + (date.getMonth() + 1)).slice(-2) + '-' + ('0' + date.getDate()).slice(-2);
                currentUpdate += 'T' + ('0' + date.getHours()).slice(-2) + ':' + ('0' + date.getMinutes()).slice(-2) + ':' + ('0' + date.getSeconds()).slice(-2);

                var lastUpdate = window.localStorage.getItem('db_update_date')

                window.localStorage.setItem('db_update_date', currentUpdate);
                window.localStorage.setItem('db_lastnews_date', lastUpdate);

                //feedback
                $("#aggiorna").attr("src", "./image/aggiorna.png");
            }
            $.each(data, function (key, val) {
                var id = val.id;
                var time = val.modified;
                var title = val.title.rendered;
                var tags = val.tags;
                var blob = JSON.stringify(val);
                FONTE.dbHandler.executeSql('INSERT OR REPLACE INTO xm24_posts VALUES (?,?,?,?,?)', [id, title, time, category, blob], function (resultSet) {
                    FONTE.updatedPostsCount += 1;
                    console.log('Voci aggiornate: ' + FONTE.updatedPostsCount);
                    if (FONTE.updatedCategoriesCount >= FONTE.categoriesList.length && FONTE.updatedPostsCount >= FONTE.neededPostsCount) {
                        //window.localStorage.setItem('has_run', 'true');

                        var date = new Date();
                        var currentUpdate = date.getFullYear() + '-' + ('0' + (date.getMonth() + 1)).slice(-2) + '-' + ('0' + date.getDate()).slice(-2);
                        currentUpdate += 'T' + ('0' + date.getHours()).slice(-2) + ':' + ('0' + date.getMinutes()).slice(-2) + ':' + ('0' + date.getSeconds()).slice(-2);

                        var lastUpdate = window.localStorage.getItem('db_update_date')

                        window.localStorage.setItem('db_update_date', currentUpdate);
                        window.localStorage.setItem('db_lastnews_date', lastUpdate);

                        toastr.info('Aggiornati ' + FONTE.updatedPostsCount + ' articoli.');

                        //feedback
                        $("#aggiorna").attr("src", "./image/aggiorna.png");
                        displayLastUpdateDate();
                    } //manca il caso in cui sono stati cancellati dei post online, vanno cancellati anche dall'app.
                }, function (error) {
                    FONTE.updatedPostsCount += 1;
                    if (FONTE.updatedCategoriesCount >= FONTE.categoriesList.length && FONTE.updatedPostsCount >= FONTE.neededPostsCount) {
                        toastr.info('Aggiornati ' + FONTE.updatedPostsCount + ' articoli.');
                        //feedback
                        $("#aggiorna").attr("src", "./image/aggiorna.png");
                    }
                });
                $.each(tags, function (key, val) {
                    aggiornaTagsToPosts(id, val);
                });
            });
            if (pagenum < totalPages) {
                pagenum += 1;
                getSinglePageRecur(url, category, pagenum)
            }
        }
        , error: JSONErrorHandler
    });
};
